diff -ruN ccp4srs-old/ccp4srs/ccp4srs_atom.cpp ccp4srs/ccp4srs/ccp4srs_atom.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_atom.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_atom.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -22,502 +22,506 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    03.02.14   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_atom  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSAtom  - atom description class
+//  **** Classes :  ccp4srs::Atom  - atom description class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2013
+//  (C) E. Krissinel 2010-2014
 //
 //  =================================================================
 //
 
-
-#ifndef  __STRING_H
 #include <string.h>
-#endif
-
-#include "mmdb/mmdb_tables.h"
 
+#include "mmdb2/mmdb_tables.h"
 #include "ccp4srs_atom.h"
+#include "ccp4srs_types.h"
 #include "ccp4srs_defs.h"
 
+namespace ccp4srs  {
+
+  Atom::Atom()  {
+    Init();
+  }
+
+  Atom::~Atom()  {}
+
+  void Atom::Init()  {
+
+    atomName    [0] = char(0);       // atom name
+    rcsbAtomName[0] = char(0);       // alternative atom name
+    oldAtomName [0] = char(0);       // old atom name
+    chemElement [0] = char(0);       // chemical element name
+    energyType  [0] = char(0);       // energy type
+    pdb_x           = -mmdb::MaxShortReal/2.0; // cartesian coordinates
+    pdb_y           = pdb_x;
+    pdb_z           = pdb_x;
+    pdbx_x          = pdb_x;         // idealized coordinates
+    pdbx_y          = pdb_x;
+    pdbx_z          = pdb_x;
+    mlib_x          = pdb_x;         // monomer library coordinates
+    mlib_y          = pdb_x;
+    mlib_z          = pdb_x;
+    atomCharge      = 0.0;           // partial charge
+    atomWeight      = 0.0;           // atomic weight (in a.u.)
+    vdwRadius       = 0.0;           // Van-Der-Waals radius
+    vdwhRadius      = 0.0;           // Van-Der-Waals radius with hydrogen
+    ionRadius       = 0.0;           // ion radius
+    atomValency     = 0;             // valency
+    atomSP          = 0;             // sp-hybridization
+    property[0]     = '-';           // RCSB chirality : 'R', 'S' or 'N'
+    property[1]     = '-';           // MLib chirality : 'R', 'S' or 'N'
+    property[2]     = '-';           // leaving atom: 'Y' or 'N'
+    property[3]     = '-';           // hydrogen bond type:
+                                     //           'D' donor
+                                     //           'A' acceptor
+                                     //           'B' both
+                                     //           'H' hydrogen candidate
+                                     //           'N' neither
+
+  }
+
+
+  mmdb::cpstr Atom::name_pdb ( mmdb::pstr aname )  {
+  int  l;
+
+    l = strlen(atomName);
+    if (l>=4)
+      return atomName;
+
+    strcpy ( aname,"    " );
+
+    if (mmdb::isMetal(chemElement))
+          strncpy ( aname,atomName,l );
+    else  strncpy ( &(aname[1]),atomName,l );
+
+    return aname;
+
+  }
+
+  mmdb::cpstr Atom::rcsb_name_pdb ( mmdb::pstr aname )  {
+  int  l;
+
+    l = strlen(rcsbAtomName);
+    if (l>=4)
+      return rcsbAtomName;
+
+    strcpy ( aname,"    " );
+
+    if (mmdb::isMetal(chemElement))
+          strncpy ( aname,rcsbAtomName,l       );
+    else  strncpy ( &(aname[1]),rcsbAtomName,l );
+
+    return aname;
 
-CCP4SRSAtom::CCP4SRSAtom()  {
-  Init();
-}
-
-CCP4SRSAtom::~CCP4SRSAtom()  {}
-
-void CCP4SRSAtom::Init()  {
-
-  atomName    [0] = char(0);       // atom name
-  rcsbAtomName[0] = char(0);       // alternative atom name
-  oldAtomName [0] = char(0);       // old atom name
-  chemElement [0] = char(0);       // chemical element name
-  energyType  [0] = char(0);       // energy type
-  pdb_x           = -MaxShortReal/2.0; // cartesian coordinates
-  pdb_y           = pdb_x;
-  pdb_z           = pdb_x;
-  pdbx_x          = pdb_x;         // idealized coordinates
-  pdbx_y          = pdb_x;
-  pdbx_z          = pdb_x;
-  mlib_x          = pdb_x;         // monomer library coordinates
-  mlib_y          = pdb_x;
-  mlib_z          = pdb_x;
-  atomCharge      = 0.0;           // partial charge
-  atomWeight      = 0.0;           // atomic weight (in a.u.)
-  vdwRadius       = 0.0;           // Van-Der-Waals radius
-  vdwhRadius      = 0.0;           // Van-Der-Waals radius with hydrogen
-  ionRadius       = 0.0;           // ion radius
-  atomValency     = 0;             // valency
-  atomSP          = 0;             // sp-hybridization
-  property[0]     = '-';           // RCSB chirality : 'R', 'S' or 'N'
-  property[1]     = '-';           // MLib chirality : 'R', 'S' or 'N'
-  property[2]     = '-';           // leaving atom: 'Y' or 'N'
-  property[3]     = '-';           // hydrogen bond type:
-                                   //           'D' donor
-                                   //           'A' acceptor
-                                   //           'B' both
-                                   //           'H' hydrogen candidate
-                                   //           'N' neither
-
-}
-
-
-cpstr CCP4SRSAtom::name_pdb ( pstr aname )  {
-int  l;
-
-  l = strlen(atomName);
-  if (l>=4)
-    return atomName;
-
-  strcpy ( aname,"    " );
-
-  if (isMetal(chemElement))  strncpy ( aname,atomName,l );
-                       else  strncpy ( &(aname[1]),atomName,l );
-
-  return aname;
-
-}
-
-cpstr CCP4SRSAtom::rcsb_name_pdb ( pstr aname )  {
-int  l;
-
-  l = strlen(rcsbAtomName);
-  if (l>=4)
-    return rcsbAtomName;
-
-  strcpy ( aname,"    " );
-
-  if (isMetal(chemElement))  strncpy ( aname,rcsbAtomName,l       );
-                       else  strncpy ( &(aname[1]),rcsbAtomName,l );
-
-  return aname;
-
-}
-
-cpstr CCP4SRSAtom::old_name_pdb ( pstr aname )  {
-int  l;
-
-  l = strlen(oldAtomName);
-  if (l>=4)
-    return oldAtomName;
-
-  strcpy ( aname,"    " );
-
-  if (isMetal(chemElement))  strncpy ( aname,oldAtomName,l       );
-                       else  strncpy ( &(aname[1]),oldAtomName,l );
-
-  return aname;
-
-}
-
-cpstr CCP4SRSAtom::element_pdb ( pstr elem )  {
-
-  if (!chemElement[0])  {
-    elem[0] = ' ';
-    elem[1] = ' ';
-  } else if (!chemElement[1])  {
-    elem[0] = ' ';
-    elem[1] = chemElement[0];
-  } else  {
-    elem[0] = chemElement[0];
-    elem[1] = chemElement[1];
-  }
-  elem[2] = char(0);
-
-  return elem;
-
-}
-
-void CCP4SRSAtom::set_energy_type ( cpstr etype )  {
-  strcpy ( energyType,etype );
-}
-
-void CCP4SRSAtom::set_old_name ( cpstr name )  {
-  strcpy ( oldAtomName,name );
-}
-
-char CCP4SRSAtom::chirality() const  {
-// ccp4's; if not set then rcsb's
-  if (property[1]!='-')  return property[1];
-  return property[0];
-}
-
-void CCP4SRSAtom::makeCAtom ( RPCAtom a )  {
-AtomName aname;
-Element  elem;
-  if (!a)  a = newCAtom();
-  a->SetAtomName    ( 0,0,name_pdb(aname),"","",element_pdb(elem) );
-  a->SetCharge      ( RMax(0.0,atomCharge) );
-  a->SetCoordinates ( pdb_x,pdb_y,pdb_z,1.0,0.0  );
-  strcpy ( a->energyType,energyType  );
-  a->sigOcc = -1.0;  // signal that atom was added from SBase
-}
-
-PCAtom CCP4SRSAtom::makeCAtom()  {
-PCAtom   a;
-AtomName aname;
-Element  elem;
-  a = newCAtom();
-  a->SetAtomName    ( 0,0,name_pdb(aname),"","",element_pdb(elem) );
-  a->SetCharge      ( RMax(0.0,atomCharge) );
-  a->SetCoordinates ( pdb_x,pdb_y,pdb_z,1.0,0.0 );
-  strcpy ( a->energyType,energyType );
-  a->sigOcc = -1.0;  // signal that atom was added from SBase
-  return a;
-}
-
-
-void CCP4SRSAtom::makeCIFTags ( PCMMCIFLoop mmCIFLoop )  {
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID        );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID        );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_TYPE_SYMBOL    );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_TYPE_ENERGY    );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_PARTIAL_CHARGE );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_X              );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_Y              );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_Z              );
-}
-
-int CCP4SRSAtom::readFromCIF_ccp4 ( PCMMCIFLoop mmCIFLoop,
-                                    int atomNo )  {
-int  rc;
-
-  rc = 0;
-  mmCIFLoop->CopyString ( atomName,sizeof(AtomName)-1,
-                          MMCIF_TAG_ATOM_ID,atomNo,rc );
-  mmCIFLoop->CopyString ( chemElement,sizeof(Element)-1,
-                          MMCIF_TAG_TYPE_SYMBOL,atomNo,rc );
-  mmCIFLoop->CopyString ( energyType,sizeof(EnergyType)-1,
-                          MMCIF_TAG_TYPE_ENERGY,atomNo,rc );
-
-  mmCIFLoop->CopyReal   ( atomCharge,MMCIF_TAG_PARTIAL_CHARGE,
-                          atomNo,rc );
-
-  if (mmCIFLoop->GetTagNo(MMCIF_TAG_X)>=0)  {
-    mmCIFLoop->CopyReal ( mlib_x,MMCIF_TAG_X,atomNo,rc );
-    mmCIFLoop->CopyReal ( mlib_y,MMCIF_TAG_Y,atomNo,rc );
-    mmCIFLoop->CopyReal ( mlib_z,MMCIF_TAG_Y,atomNo,rc );
-  } else if (mmCIFLoop->GetTagNo(MMCIF_TAG_MODEL_CARTN_X)>=0)  {
-    mmCIFLoop->CopyReal ( mlib_x,MMCIF_TAG_MODEL_CARTN_X,atomNo,rc );
-    mmCIFLoop->CopyReal ( mlib_y,MMCIF_TAG_MODEL_CARTN_Y,atomNo,rc );
-    mmCIFLoop->CopyReal ( mlib_z,MMCIF_TAG_MODEL_CARTN_Z,atomNo,rc );
-  }
-  /*else  {
-    mlib_x = 0.0;
-    mlib_y = 0.0;
-    mlib_z = 0.0;
   }
-  */
 
-  return rc;
+  mmdb::cpstr Atom::old_name_pdb ( mmdb::pstr aname )  {
+  int  l;
 
-}
+    l = strlen(oldAtomName);
+    if (l>=4)
+      return oldAtomName;
 
-int CCP4SRSAtom::readFromCIF_rcsb ( PCMMCIFLoop mmCIFLoop,
-                                    int atomNo )  {
-pstr p;
-int  rc;
-
-  rc = 0;
-  mmCIFLoop->CopyString  ( atomName,sizeof(AtomName)-1,
-                           MMCIF_TAG_ATOM_ID,atomNo,rc );
-  mmCIFLoop->CopyString  ( rcsbAtomName,sizeof(AtomName)-1,
-                           MMCIF_TAG_ALT_ATOM_ID,atomNo,rc );
-  mmCIFLoop->CopyString  ( chemElement,sizeof(Element)-1,
-                           MMCIF_TAG_TYPE_SYMBOL,atomNo,rc );
-
-  if (mmCIFLoop->GetTagNo(MMCIF_TAG_MODEL_CARTN_X)>=0)  {
-    mmCIFLoop->CopyReal ( pdb_x,MMCIF_TAG_MODEL_CARTN_X,atomNo,rc );
-    mmCIFLoop->CopyReal ( pdb_y,MMCIF_TAG_MODEL_CARTN_Y,atomNo,rc );
-    mmCIFLoop->CopyReal ( pdb_z,MMCIF_TAG_MODEL_CARTN_Z,atomNo,rc );
-  }
-  if (mmCIFLoop->GetTagNo(MMCIF_TAG_PDBX_MODEL_CARTN_X)>=0)  {
-    mmCIFLoop->CopyReal ( pdbx_x,MMCIF_TAG_PDBX_MODEL_CARTN_X,atomNo,rc );
-    mmCIFLoop->CopyReal ( pdbx_y,MMCIF_TAG_PDBX_MODEL_CARTN_Y,atomNo,rc );
-    mmCIFLoop->CopyReal ( pdbx_z,MMCIF_TAG_PDBX_MODEL_CARTN_Z,atomNo,rc );
-  }
-
-  p = mmCIFLoop->GetString ( MMCIF_TAG_PDBX_STEREO_CONFIG,
-                             atomNo,rc );
-  if (!p)  property[0] = '-';
-     else  property[0] = p[0];
-
-
-  p = mmCIFLoop->GetString ( MMCIF_TAG_PDBX_LEAVING_ATOM_FLAG,
-                             atomNo,rc );
-  if (!p)              property[2] = 'N';
-  else if (p[0]=='Y')  property[2] = 'Y';
-                 else  property[2] = 'N';
-
-  return rc;
-
-}
-
-int CCP4SRSAtom::readFromCIF ( PCMMCIFStruct mmCIFStruct )  {
-pstr p;
-int  rc;
-
-  rc = 0;
-  p = mmCIFStruct->GetString ( MMCIF_TAG_ATOM_ID,rc );
-  if (p) strcpy ( atomName,p );
-  p = mmCIFStruct->GetString ( MMCIF_TAG_ALT_ATOM_ID,rc );
-  if (p) strcpy ( rcsbAtomName,p );
-  p = mmCIFStruct->GetString ( MMCIF_TAG_TYPE_SYMBOL,rc );
-  if (p) strcpy ( chemElement,p );
-  p = mmCIFStruct->GetString ( MMCIF_TAG_TYPE_ENERGY,rc );
-  if (p) strcpy ( energyType,p );
-
-  rc = mmCIFStruct->GetReal ( atomCharge,MMCIF_TAG_PARTIAL_CHARGE );
-
-  if (mmCIFStruct->GetTagNo(MMCIF_TAG_X)>=0)  {
-    rc = mmCIFStruct->GetReal ( mlib_x,MMCIF_TAG_X );
-    rc = mmCIFStruct->GetReal ( mlib_y,MMCIF_TAG_Y );
-    rc = mmCIFStruct->GetReal ( mlib_z,MMCIF_TAG_Y );
-  } else if (mmCIFStruct->GetTagNo(MMCIF_TAG_MODEL_CARTN_X)>=0)  {
-    rc = mmCIFStruct->GetReal ( pdb_x,MMCIF_TAG_MODEL_CARTN_X );
-    rc = mmCIFStruct->GetReal ( pdb_y,MMCIF_TAG_MODEL_CARTN_Y );
-    rc = mmCIFStruct->GetReal ( pdb_z,MMCIF_TAG_MODEL_CARTN_Y );
-    rc = mmCIFStruct->GetReal ( pdbx_x,MMCIF_TAG_PDBX_MODEL_CARTN_X );
-    rc = mmCIFStruct->GetReal ( pdbx_y,MMCIF_TAG_PDBX_MODEL_CARTN_Y );
-    rc = mmCIFStruct->GetReal ( pdbx_z,MMCIF_TAG_PDBX_MODEL_CARTN_Y );
-    p  = mmCIFStruct->GetString ( MMCIF_TAG_PDBX_LEAVING_ATOM_FLAG,rc );
+    strcpy ( aname,"    " );
+
+    if (mmdb::isMetal(chemElement))
+          strncpy ( aname,oldAtomName,l       );
+    else  strncpy ( &(aname[1]),oldAtomName,l );
+
+    return aname;
+
+  }
+
+  mmdb::cpstr Atom::element_pdb ( mmdb::pstr elem )  {
+
+    if (!chemElement[0])  {
+      elem[0] = ' ';
+      elem[1] = ' ';
+    } else if (!chemElement[1])  {
+      elem[0] = ' ';
+      elem[1] = chemElement[0];
+    } else  {
+      elem[0] = chemElement[0];
+      elem[1] = chemElement[1];
+    }
+    elem[2] = char(0);
+
+    return elem;
+
+  }
+
+  void Atom::set_energy_type ( mmdb::cpstr etype )  {
+    strcpy ( energyType,etype );
+  }
+
+  void Atom::set_old_name ( mmdb::cpstr name )  {
+    strcpy ( oldAtomName,name );
+  }
+
+  char Atom::chirality() const  {
+  // ccp4's; if not set then rcsb's
+    if (property[1]!='-')  return property[1];
+    return property[0];
+  }
+
+  void Atom::makeAtom ( mmdb::RPAtom a )  {
+  mmdb::AtomName aname;
+  mmdb::Element  elem;
+    if (!a)  a = mmdb::newAtom();
+    a->SetAtomName    ( 0,0,name_pdb(aname),"","",element_pdb(elem) );
+    a->SetCharge      ( mmdb::RMax(0.0,atomCharge) );
+    a->SetCoordinates ( pdb_x,pdb_y,pdb_z,1.0,0.0  );
+    strcpy ( a->energyType,energyType  );
+    a->sigOcc = -1.0;  // signal that atom was added from SBase
+  }
+
+  mmdb::PAtom Atom::makeAtom()  {
+  mmdb::PAtom   a;
+  mmdb::AtomName aname;
+  mmdb::Element  elem;
+    a = mmdb::newAtom();
+    a->SetAtomName    ( 0,0,name_pdb(aname),"","",element_pdb(elem) );
+    a->SetCharge      ( mmdb::RMax(0.0,atomCharge) );
+    a->SetCoordinates ( pdb_x,pdb_y,pdb_z,1.0,0.0 );
+    strcpy ( a->energyType,energyType );
+    a->sigOcc = -1.0;  // signal that atom was added from SBase
+    return a;
+  }
+
+
+  void Atom::makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop )  {
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID        );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID        );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_TYPE_SYMBOL    );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_TYPE_ENERGY    );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_PARTIAL_CHARGE );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_X              );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_Y              );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_Z              );
+  }
+
+  int Atom::readFromCIF_ccp4 ( mmdb::mmcif::PLoop mmCIFLoop,
+                                      int atomNo )  {
+  int  rc;
+
+    rc = 0;
+    mmCIFLoop->CopyString ( atomName,sizeof(mmdb::AtomName)-1,
+                            MMCIF_TAG_ATOM_ID,atomNo,rc );
+    mmCIFLoop->CopyString ( chemElement,sizeof(mmdb::Element)-1,
+                            MMCIF_TAG_TYPE_SYMBOL,atomNo,rc );
+    mmCIFLoop->CopyString ( energyType,sizeof(mmdb::EnergyType)-1,
+                            MMCIF_TAG_TYPE_ENERGY,atomNo,rc );
+
+    mmCIFLoop->CopyReal   ( atomCharge,MMCIF_TAG_PARTIAL_CHARGE,
+                            atomNo,rc );
+
+    if (mmCIFLoop->GetTagNo(MMCIF_TAG_X)>=0)  {
+      mmCIFLoop->CopyReal ( mlib_x,MMCIF_TAG_X,atomNo,rc );
+      mmCIFLoop->CopyReal ( mlib_y,MMCIF_TAG_Y,atomNo,rc );
+      mmCIFLoop->CopyReal ( mlib_z,MMCIF_TAG_Y,atomNo,rc );
+    } else if (mmCIFLoop->GetTagNo(MMCIF_TAG_MODEL_CARTN_X)>=0)  {
+      mmCIFLoop->CopyReal ( mlib_x,MMCIF_TAG_MODEL_CARTN_X,atomNo,rc );
+      mmCIFLoop->CopyReal ( mlib_y,MMCIF_TAG_MODEL_CARTN_Y,atomNo,rc );
+      mmCIFLoop->CopyReal ( mlib_z,MMCIF_TAG_MODEL_CARTN_Z,atomNo,rc );
+    }
+    /*else  {
+      mlib_x = 0.0;
+      mlib_y = 0.0;
+      mlib_z = 0.0;
+    }
+    */
+
+    return rc;
+
+  }
+
+  int Atom::readFromCIF_rcsb ( mmdb::mmcif::PLoop mmCIFLoop,
+                                      int atomNo )  {
+  mmdb::pstr p;
+  int        rc;
+
+    rc = 0;
+    mmCIFLoop->CopyString  ( atomName,sizeof(mmdb::AtomName)-1,
+                             MMCIF_TAG_ATOM_ID,atomNo,rc );
+    mmCIFLoop->CopyString  ( rcsbAtomName,sizeof(mmdb::AtomName)-1,
+                             MMCIF_TAG_ALT_ATOM_ID,atomNo,rc );
+    mmCIFLoop->CopyString  ( chemElement,sizeof(mmdb::Element)-1,
+                             MMCIF_TAG_TYPE_SYMBOL,atomNo,rc );
+
+    if (mmCIFLoop->GetTagNo(MMCIF_TAG_MODEL_CARTN_X)>=0)  {
+      mmCIFLoop->CopyReal ( pdb_x,MMCIF_TAG_MODEL_CARTN_X,atomNo,rc );
+      mmCIFLoop->CopyReal ( pdb_y,MMCIF_TAG_MODEL_CARTN_Y,atomNo,rc );
+      mmCIFLoop->CopyReal ( pdb_z,MMCIF_TAG_MODEL_CARTN_Z,atomNo,rc );
+    }
+    if (mmCIFLoop->GetTagNo(MMCIF_TAG_PDBX_MODEL_CARTN_X)>=0)  {
+      mmCIFLoop->CopyReal ( pdbx_x,MMCIF_TAG_PDBX_MODEL_CARTN_X,atomNo,rc );
+      mmCIFLoop->CopyReal ( pdbx_y,MMCIF_TAG_PDBX_MODEL_CARTN_Y,atomNo,rc );
+      mmCIFLoop->CopyReal ( pdbx_z,MMCIF_TAG_PDBX_MODEL_CARTN_Z,atomNo,rc );
+    }
+
+    p = mmCIFLoop->GetString ( MMCIF_TAG_PDBX_STEREO_CONFIG,
+                               atomNo,rc );
+    if (!p)  property[0] = '-';
+       else  property[0] = p[0];
+
+
+    p = mmCIFLoop->GetString ( MMCIF_TAG_PDBX_LEAVING_ATOM_FLAG,
+                               atomNo,rc );
     if (!p)              property[2] = 'N';
     else if (p[0]=='Y')  property[2] = 'Y';
                    else  property[2] = 'N';
+
+    return rc;
+
   }
-  /*
-  else  {
-    pdb_x  = 0.0;
-    pdb_y  = 0.0;
-    pdb_z  = 0.0;
-    pdbx_x = 0.0;
-    pdbx_y = 0.0;
-    pdbx_z = 0.0;
-  }
-  */
 
-  return rc;
+  int Atom::readFromCIF ( mmdb::mmcif::PStruct mmCIFStruct )  {
+  mmdb::pstr p;
+  int        rc;
+
+    rc = 0;
+    p = mmCIFStruct->GetString ( MMCIF_TAG_ATOM_ID,rc );
+    if (p) strcpy ( atomName,p );
+    p = mmCIFStruct->GetString ( MMCIF_TAG_ALT_ATOM_ID,rc );
+    if (p) strcpy ( rcsbAtomName,p );
+    p = mmCIFStruct->GetString ( MMCIF_TAG_TYPE_SYMBOL,rc );
+    if (p) strcpy ( chemElement,p );
+    p = mmCIFStruct->GetString ( MMCIF_TAG_TYPE_ENERGY,rc );
+    if (p) strcpy ( energyType,p );
+
+    rc = mmCIFStruct->GetReal ( atomCharge,MMCIF_TAG_PARTIAL_CHARGE );
+
+    if (mmCIFStruct->GetTagNo(MMCIF_TAG_X)>=0)  {
+      rc = mmCIFStruct->GetReal ( mlib_x,MMCIF_TAG_X );
+      rc = mmCIFStruct->GetReal ( mlib_y,MMCIF_TAG_Y );
+      rc = mmCIFStruct->GetReal ( mlib_z,MMCIF_TAG_Y );
+    } else if (mmCIFStruct->GetTagNo(MMCIF_TAG_MODEL_CARTN_X)>=0)  {
+      rc = mmCIFStruct->GetReal ( pdb_x,MMCIF_TAG_MODEL_CARTN_X );
+      rc = mmCIFStruct->GetReal ( pdb_y,MMCIF_TAG_MODEL_CARTN_Y );
+      rc = mmCIFStruct->GetReal ( pdb_z,MMCIF_TAG_MODEL_CARTN_Y );
+      rc = mmCIFStruct->GetReal ( pdbx_x,MMCIF_TAG_PDBX_MODEL_CARTN_X );
+      rc = mmCIFStruct->GetReal ( pdbx_y,MMCIF_TAG_PDBX_MODEL_CARTN_Y );
+      rc = mmCIFStruct->GetReal ( pdbx_z,MMCIF_TAG_PDBX_MODEL_CARTN_Y );
+      p  = mmCIFStruct->GetString ( MMCIF_TAG_PDBX_LEAVING_ATOM_FLAG,rc );
+      if (!p)              property[2] = 'N';
+      else if (p[0]=='Y')  property[2] = 'Y';
+                     else  property[2] = 'N';
+    }
+    /*
+    else  {
+      pdb_x  = 0.0;
+      pdb_y  = 0.0;
+      pdb_z  = 0.0;
+      pdbx_x = 0.0;
+      pdbx_y = 0.0;
+      pdbx_z = 0.0;
+    }
+    */
+
+    return rc;
+
+  }
 
-}
+  void Atom::writeToCIF  ( mmdb::mmcif::PLoop mmCIFLoop, mmdb::cpstr monID )  {
 
-void CCP4SRSAtom::writeToCIF  ( PCMMCIFLoop mmCIFLoop, cpstr monID )  {
+    mmCIFLoop->AddString ( monID      ,false );
 
-  mmCIFLoop->AddString ( monID      ,False );
+    mmCIFLoop->AddString ( atomName   ,false );
+    mmCIFLoop->AddString ( chemElement,false );
+    mmCIFLoop->AddString ( energyType ,false );
+
+    mmCIFLoop->AddReal   ( atomCharge ,"%10.3f" );
+    mmCIFLoop->AddReal   ( mlib_x     ,"%10.3f" );
+    mmCIFLoop->AddReal   ( mlib_y     ,"%10.3f" );
+    mmCIFLoop->AddReal   ( mlib_z     ,"%10.3f" );
 
-  mmCIFLoop->AddString ( atomName   ,False );
-  mmCIFLoop->AddString ( chemElement,False );
-  mmCIFLoop->AddString ( energyType ,False );
-
-  mmCIFLoop->AddReal   ( atomCharge ,"%10.3f" );
-  mmCIFLoop->AddReal   ( mlib_x     ,"%10.3f" );
-  mmCIFLoop->AddReal   ( mlib_y     ,"%10.3f" );
-  mmCIFLoop->AddReal   ( mlib_z     ,"%10.3f" );
-
-}
-
-/*
-data_comp_ATP
-#
-loop_
-_chem_comp_atom.comp_id
-_chem_comp_atom.atom_id
-_chem_comp_atom.type_symbol
-_chem_comp_atom.type_energy
-_chem_comp_atom.partial_charge
-_chem_comp_atom.x
-_chem_comp_atom.y
-_chem_comp_atom.z
- ATP           O2A    O    OP       -0.500      0.000    0.000    0.000
-*/
-
-void CCP4SRSAtom::copy ( PCCP4SRSAtom atom )  {
-
-  strcpy ( atomName    ,atom->name       () );
-  strcpy ( rcsbAtomName,atom->rcsb_name  () );
-  strcpy ( oldAtomName ,atom->old_name   () );
-  strcpy ( chemElement ,atom->element    () );
-  strcpy ( energyType  ,atom->energy_type() );
-
-  pdb_x  = atom->x();
-  pdb_y  = atom->y();
-  pdb_z  = atom->z();
-  mlib_x = atom->x_mlib();
-  mlib_y = atom->y_mlib();
-  mlib_z = atom->z_mlib();
-  pdbx_x = atom->x_pdbx();
-  pdbx_y = atom->y_pdbx();
-  pdbx_z = atom->z_pdbx();
-
-  atomCharge  = atom->charge        ();
-  atomWeight  = atom->weight        ();
-  vdwRadius   = atom->vdw_radius    ();
-  vdwhRadius  = atom->vdwh_radius   ();
-  ionRadius   = atom->ion_radius    ();
-  atomValency = atom->valency       ();
-  atomSP      = atom->sp            ();
-  property[0] = atom->rcsb_chirality();
-  property[1] = atom->chirality     ();
-  property[2] = atom->leaving       ();
-  property[3] = atom->hb_type       ();
-
-}
-
-
-void CCP4SRSAtom::merge ( PCCP4SRSAtom atom )  {
-
-  if (!atomName    [0])  strcpy ( atomName    ,atom->name       () );
-  if (!rcsbAtomName[0])  strcpy ( rcsbAtomName,atom->rcsb_name  () );
-  if (!oldAtomName [0])  strcpy ( oldAtomName ,atom->old_name   () );
-  if (!chemElement [0])  strcpy ( chemElement ,atom->element    () );
-  if (!energyType  [0])  strcpy ( energyType  ,atom->energy_type() );
-
-  if (pdb_x==-MaxShortReal)  {
-    pdb_x = atom->x();
-    pdb_y = atom->y();
-    pdb_z = atom->z();
   }
-  if (pdbx_x==-MaxShortReal)  {
+
+  /*
+  data_comp_ATP
+  #
+  loop_
+  _chem_comp_atom.comp_id
+  _chem_comp_atom.atom_id
+  _chem_comp_atom.type_symbol
+  _chem_comp_atom.type_energy
+  _chem_comp_atom.partial_charge
+  _chem_comp_atom.x
+  _chem_comp_atom.y
+  _chem_comp_atom.z
+   ATP           O2A    O    OP       -0.500      0.000    0.000    0.000
+  */
+
+  void Atom::copy ( PAtom atom )  {
+
+    strcpy ( atomName    ,atom->name       () );
+    strcpy ( rcsbAtomName,atom->rcsb_name  () );
+    strcpy ( oldAtomName ,atom->old_name   () );
+    strcpy ( chemElement ,atom->element    () );
+    strcpy ( energyType  ,atom->energy_type() );
+
+    pdb_x  = atom->x();
+    pdb_y  = atom->y();
+    pdb_z  = atom->z();
+    mlib_x = atom->x_mlib();
+    mlib_y = atom->y_mlib();
+    mlib_z = atom->z_mlib();
     pdbx_x = atom->x_pdbx();
     pdbx_y = atom->y_pdbx();
     pdbx_z = atom->z_pdbx();
+
+    atomCharge  = atom->charge        ();
+    atomWeight  = atom->weight        ();
+    vdwRadius   = atom->vdw_radius    ();
+    vdwhRadius  = atom->vdwh_radius   ();
+    ionRadius   = atom->ion_radius    ();
+    atomValency = atom->valency       ();
+    atomSP      = atom->sp            ();
+    property[0] = atom->rcsb_chirality();
+    property[1] = atom->chirality     ();
+    property[2] = atom->leaving       ();
+    property[3] = atom->hb_type       ();
+
   }
-  if (mlib_x==-MaxShortReal)  {
-    mlib_x = atom->x_mlib();
-    mlib_y = atom->y_mlib();
-    mlib_z = atom->z_mlib();
+
+
+  void Atom::merge ( PAtom atom )  {
+
+    if (!atomName    [0])  strcpy ( atomName    ,atom->name       () );
+    if (!rcsbAtomName[0])  strcpy ( rcsbAtomName,atom->rcsb_name  () );
+    if (!oldAtomName [0])  strcpy ( oldAtomName ,atom->old_name   () );
+    if (!chemElement [0])  strcpy ( chemElement ,atom->element    () );
+    if (!energyType  [0])  strcpy ( energyType  ,atom->energy_type() );
+
+    if (pdb_x==-mmdb::MaxShortReal)  {
+      pdb_x = atom->x();
+      pdb_y = atom->y();
+      pdb_z = atom->z();
+    }
+    if (pdbx_x==-mmdb::MaxShortReal)  {
+      pdbx_x = atom->x_pdbx();
+      pdbx_y = atom->y_pdbx();
+      pdbx_z = atom->z_pdbx();
+    }
+    if (mlib_x==-mmdb::MaxShortReal)  {
+      mlib_x = atom->x_mlib();
+      mlib_y = atom->y_mlib();
+      mlib_z = atom->z_mlib();
+    }
+
+    if (atomCharge==0.0)  atomCharge  = atom->charge     ();
+    if (atomWeight==0.0)  atomWeight  = atom->weight     ();
+    if (vdwRadius ==0.0)  vdwRadius   = atom->vdw_radius ();
+    if (vdwhRadius==0.0)  vdwhRadius  = atom->vdwh_radius();
+    if (ionRadius ==0.0)  ionRadius   = atom->ion_radius ();
+    if (!atomValency)     atomValency = atom->valency    ();
+    if (!atomSP)          atomSP      = atom->sp         ();
+    if (property[0]=='-') property[0] = atom->rcsb_chirality();
+    if (property[1]=='-') property[1] = atom->chirality     ();
+    if (property[2]=='-') property[2] = atom->leaving       ();
+    if (property[3]=='-') property[3] = atom->hb_type       ();
+
+  }
+
+
+  void Atom::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
+    memIO->put_line     ( atomName     );
+    memIO->put_line     ( rcsbAtomName );
+    memIO->put_line     ( oldAtomName  );
+    memIO->put_line     ( chemElement  );
+    memIO->put_line     ( energyType   );
+    memIO->put_float    ( pdb_x        );
+    memIO->put_float    ( pdb_y        );
+    memIO->put_float    ( pdb_z        );
+    memIO->put_float    ( pdbx_x       );
+    memIO->put_float    ( pdbx_y       );
+    memIO->put_float    ( pdbx_z       );
+    memIO->put_float    ( mlib_x       );
+    memIO->put_float    ( mlib_y       );
+    memIO->put_float    ( mlib_z       );
+    memIO->put_float    ( atomCharge   );
+    memIO->put_float    ( atomWeight   );
+    memIO->put_float    ( vdwRadius    );
+    memIO->put_float    ( vdwhRadius   );
+    memIO->put_float    ( ionRadius    );
+    memIO->put_integer  ( atomValency  );
+    memIO->put_integer  ( atomSP       );
+    memIO->write_buffer ( property,sizeof(property) );
+  }
+
+  bool Atom::read_mem  ( PMemIO memIO, int version,
+                                bool * Ok )  {
+  UNUSED_ARGUMENT(version);
+  bool success;
+    if (Ok)  success = *Ok;
+       else  success = true;
+    memIO->get_line    ( atomName    ,&success );
+    memIO->get_line    ( rcsbAtomName,&success );
+    memIO->get_line    ( oldAtomName ,&success );
+    memIO->get_line    ( chemElement ,&success );
+    memIO->get_line    ( energyType  ,&success );
+    memIO->get_float   ( pdb_x       ,&success );
+    memIO->get_float   ( pdb_y       ,&success );
+    memIO->get_float   ( pdb_z       ,&success );
+    memIO->get_float   ( pdbx_x      ,&success );
+    memIO->get_float   ( pdbx_y      ,&success );
+    memIO->get_float   ( pdbx_z      ,&success );
+    memIO->get_float   ( mlib_x      ,&success );
+    memIO->get_float   ( mlib_y      ,&success );
+    memIO->get_float   ( mlib_z      ,&success );
+    memIO->get_float   ( atomCharge  ,&success );
+    memIO->get_float   ( atomWeight  ,&success );
+    memIO->get_float   ( vdwRadius   ,&success );
+    memIO->get_float   ( vdwhRadius  ,&success );
+    memIO->get_float   ( ionRadius   ,&success );
+    memIO->get_integer ( atomValency ,&success );
+    memIO->get_integer ( atomSP      ,&success );
+    if (version<2)  {
+      memIO->read_buffer ( &(property[1]),3,&success );
+      property[0] = property[1];
+    } else
+      memIO->read_buffer ( property,sizeof(property),&success );
+    if (Ok) *Ok = success;
+    return success;
+  }
+
+
+  void  get_atom_from_cif ( int & index, mmdb::mmcif::PLoop loop,
+                            mmdb::cpstr Tag,
+                            int row,Container<Atom> & atoms,
+                            int & rc )  {
+  mmdb::pstr p;
+     p = loop->GetString ( Tag,row,rc );
+     if (!p)                     index = -1;
+     else if (!strcmp(p,"n/a"))  index = AtomID_NA;
+                           else  index = atoms.index ( p );
+  }
+
+  void  get_atom_from_cif ( int & index, mmdb::mmcif::PStruct mmCIFStruct,
+                            mmdb::cpstr Tag,
+                            Container<Atom> & atoms,
+                            int & rc )  {
+  mmdb::pstr p;
+     p = mmCIFStruct->GetString ( Tag,rc );
+     if (!p)                     index = -1;
+     else if (!strcmp(p,"n/a"))  index = AtomID_NA;
+                           else  index = atoms.index ( p );
+  }
+
+  void add_atom_to_cif ( mmdb::mmcif::PLoop loop, int atom_no,
+                         Container<Atom> & atoms )  {
+    if ((atom_no>=0) && (atom_no<atoms.numberOf()))
+         loop->AddString ( atoms.at(atom_no)->name(),false );
+    else if (atom_no==AtomID_NA)
+         loop->AddString ( "n/a",false );
+    else loop->AddNoData ( mmdb::mmcif::CIF_NODATA_DOT );
   }
 
-  if (atomCharge==0.0)  atomCharge  = atom->charge     ();
-  if (atomWeight==0.0)  atomWeight  = atom->weight     ();
-  if (vdwRadius ==0.0)  vdwRadius   = atom->vdw_radius ();
-  if (vdwhRadius==0.0)  vdwhRadius  = atom->vdwh_radius();
-  if (ionRadius ==0.0)  ionRadius   = atom->ion_radius ();
-  if (!atomValency)     atomValency = atom->valency    ();
-  if (!atomSP)          atomSP      = atom->sp         ();
-  if (property[0]=='-') property[0] = atom->rcsb_chirality();
-  if (property[1]=='-') property[1] = atom->chirality     ();
-  if (property[2]=='-') property[2] = atom->leaving       ();
-  if (property[3]=='-') property[3] = atom->hb_type       ();
-
-}
-
-
-void CCP4SRSAtom::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(version);
-  memIO->put_line     ( atomName     );
-  memIO->put_line     ( rcsbAtomName );
-  memIO->put_line     ( oldAtomName  );
-  memIO->put_line     ( chemElement  );
-  memIO->put_line     ( energyType   );
-  memIO->put_float    ( pdb_x        );
-  memIO->put_float    ( pdb_y        );
-  memIO->put_float    ( pdb_z        );
-  memIO->put_float    ( pdbx_x       );
-  memIO->put_float    ( pdbx_y       );
-  memIO->put_float    ( pdbx_z       );
-  memIO->put_float    ( mlib_x       );
-  memIO->put_float    ( mlib_y       );
-  memIO->put_float    ( mlib_z       );
-  memIO->put_float    ( atomCharge   );
-  memIO->put_float    ( atomWeight   );
-  memIO->put_float    ( vdwRadius    );
-  memIO->put_float    ( vdwhRadius   );
-  memIO->put_float    ( ionRadius    );
-  memIO->put_integer  ( atomValency  );
-  memIO->put_integer  ( atomSP       );
-  memIO->write_buffer ( property,sizeof(property) );
-}
-
-Boolean CCP4SRSAtom::read_mem  ( PCMemIO memIO, int version,
-                                 Boolean * Ok )  {
-UNUSED_ARGUMENT(version);
-Boolean success;
-  if (Ok)  success = *Ok;
-     else  success = True;
-  memIO->get_line    ( atomName    ,&success );
-  memIO->get_line    ( rcsbAtomName,&success );
-  memIO->get_line    ( oldAtomName ,&success );
-  memIO->get_line    ( chemElement ,&success );
-  memIO->get_line    ( energyType  ,&success );
-  memIO->get_float   ( pdb_x       ,&success );
-  memIO->get_float   ( pdb_y       ,&success );
-  memIO->get_float   ( pdb_z       ,&success );
-  memIO->get_float   ( pdbx_x      ,&success );
-  memIO->get_float   ( pdbx_y      ,&success );
-  memIO->get_float   ( pdbx_z      ,&success );
-  memIO->get_float   ( mlib_x      ,&success );
-  memIO->get_float   ( mlib_y      ,&success );
-  memIO->get_float   ( mlib_z      ,&success );
-  memIO->get_float   ( atomCharge  ,&success );
-  memIO->get_float   ( atomWeight  ,&success );
-  memIO->get_float   ( vdwRadius   ,&success );
-  memIO->get_float   ( vdwhRadius  ,&success );
-  memIO->get_float   ( ionRadius   ,&success );
-  memIO->get_integer ( atomValency ,&success );
-  memIO->get_integer ( atomSP      ,&success );
-  if (version<2)  {
-    memIO->read_buffer ( &(property[1]),3,&success );
-    property[0] = property[1];
-  } else
-    memIO->read_buffer ( property,sizeof(property),&success );
-  if (Ok) *Ok = success;
-  return success;
-}
-
-
-void  get_atom_from_cif ( int & index, PCMMCIFLoop loop, cpstr Tag,
-                          int row,CCP4SRSContainer<CCP4SRSAtom> & atoms,
-                          int & rc )  {
-pstr p;
-   p = loop->GetString ( Tag,row,rc );
-   if (!p)                     index = -1;
-   else if (!strcmp(p,"n/a"))  index = CCP4SRSAtomID_NA;
-                         else  index = atoms.index ( p );
-}
-
-void  get_atom_from_cif ( int & index, PCMMCIFStruct mmCIFStruct,
-                          cpstr Tag,
-                          CCP4SRSContainer<CCP4SRSAtom> & atoms,
-                          int & rc )  {
-pstr p;
-   p = mmCIFStruct->GetString ( Tag,rc );
-   if (!p)                     index = -1;
-   else if (!strcmp(p,"n/a"))  index = CCP4SRSAtomID_NA;
-                         else  index = atoms.index ( p );
-}
-
-void add_atom_to_cif ( PCMMCIFLoop loop, int atom_no,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-  if ((atom_no>=0) && (atom_no<atoms.numberOf()))
-       loop->AddString ( atoms.at(atom_no)->name(),False );
-  else if (atom_no==CCP4SRSAtomID_NA)
-       loop->AddString ( "n/a",False );
-  else loop->AddNoData ( CIF_NODATA_DOT );
-}
+}  // namespace ccp4srs
